/* Ce programme va afficher tous les entiers premiers compris entre 2 et max */
/* en utilisant la mthode du crible d'eratosthne                            */
#include <stdio.h>
#include <stdlib.h>


#define RAYE 0

int main(int argc, char ** argv)
{
  int *crible; /* Tableau servant de crible */
  int max;
  int i, j;
  
  if ( argc == 1 ) 
  {
      /* L'utilisateur a oubli l'argument */
      fprintf(stderr,"Usage : %s nb\n",argv[0]);
      return EXIT_FAILURE;
  }

  max = atoi(argv[1]);
  
  /* On alloue suffisamment de  mmoire  */
  /* pour que crible[i] corresponde  i  */
  /* (a minimise les risques d'erreurs) */     
  crible = (int *) malloc((max+1) * sizeof(int));
  /* Remplissage du tableau */
  for (i=0; i<=max; i++)
    crible[i]= i ;

  /* Partie crible */
  /* On commence  2 */
  for(i=2;i<=max;i++)
      if (crible[i] != RAYE)  /* Il faut "rayer" les multiples */
          for (j=2*i; j <= max ; j = j + i)
              crible[j] = RAYE;
  
  /* Partie affichage */
  for (i=0; i<= max; i++)
    if (crible[i] != RAYE )
        printf(" %d", crible[i]);
  printf("\n");

  /* facultatif */
  free(crible);
  return EXIT_SUCCESS;
}
