/* Ce programme calcule les racines d'une quation du second degr */

/*
   ATTENTION, pour le compiler : 
   gcc -Wextra -Wall -lm racines2.c -o racines2
*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>


int main(int argc, char **argv)
{
    float a, b, c;
    float delta;
  
    if ( argc != 4 ) 
    {
        /* L'utilisateur a oubli l'argument */
        fprintf(stderr,"Usage : %s a b c\n",argv[0]);
        return EXIT_FAILURE;
    }
    a = atof(argv[1]);
    b = atof(argv[2]);
    c = atof(argv[3]);
    
    printf("Le polynome est : %f * x^2 + %f * x + %f \n", a, b, c);
 
    if (a == 0) 
        if (b == 0) printf("Equation triviale. \n");
        else
            /* Le coef b est different de 0 */
            printf("La solution est unique : x = %f \n", -c/b);
    else 
        /* a  est non nul */
    {
        delta = b * b - 4 * a * c;
        if (delta > 0) 
            /* Delta positf */
            printf("Deux solutions : x1 = %f, x2 = %f \n", (-b + sqrt(delta)) / (2 * a), (-b - sqrt(delta)) / (2 * a));
        else 
            if (delta == 0)	printf("Une solution double : x1 = %f \n", -b  / (2 * a));
            else
                /* Delta negatif, solutions complexes */
                printf("Les solutions sont complexes x1 = %f + i * %f\n  x2 = %f - i * %f \n ", -b/(2*a), sqrt(-delta) / (2*a), 
                -b/(2*a), sqrt(-delta) / (2*a) );     
    }  
  
  return EXIT_SUCCESS;
}

